package br.com.bvmf.umdftcp.sample;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

public class InboundThread extends Thread {
	private Socket inboundSocket = null;
	private Socket outboundSocket = null;
	public static final Logger log = Logger.getLogger("InflatorProxy");
	
	public InboundThread(Socket local) {
		super("InboundThread");
		this.inboundSocket = local;
	}
	
	public void start() {
		OutboundThread outboundThread = new OutboundThread(inboundSocket);
		outboundThread.start();
		this.outboundSocket = outboundThread.getOutboundSocket();
		super.start();
	}
	
	public void run() {
		byte[] buffer = new byte[32768];
		InputStream in = null;
		OutputStream out = null;
		
		try {
	    	// Reads from the inbound socket (local) and writes to outbound socket (remote)			
			in =  inboundSocket.getInputStream();
			out = outboundSocket.getOutputStream();
			
			int read_bytes = 0;
			do {
				read_bytes = in.read(buffer);
				if (read_bytes > 0) {
            		out.write(buffer, 0, read_bytes);
            		log.log(Level.FINE, "SENT BYTES:["+new String(buffer, 0, read_bytes)+"]");
				}
			} while (read_bytes != -1);
			
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
        	try {
        		inboundSocket.close();
        	} catch (Exception e) {}
        }
	}
}
