/////////////////////////////////////////////////////////
//
//  EXONERAO DE RESPONSABILIDADE
//
// A Bolsa de Mercadorias & Futuros-BM&F fornece as informaes contidas neste cdigo fonte com propsito unicamente
// informativo e as disponibiliza apenas para atender s necessidades dos interessados em conhecer a tecnologia de referncia e
// suas convenincias. A Bolsa de Mercadorias & Futuros-BM&F no garante acurcia, integridade, perfeio ou ajuste a qualquer propsito
// especfico de tais informaes, tampouco aceita qualquer encargo, obrigao ou responsabilidade pelo uso das mesmas. As informaes
// disponibilizadas so obtidas de fontes entendidas como confiveis. No entanto, a Bolsa de Mercadorias & Futuros-BM&F no declara que as informaes
// disponibilizadas neste cdigo de referncia sejam verificadas, atualizadas e precisas. Devido  possibilidade de erro humano ou
// mecnico, bem como a outros fatores, a Bolsa de Mercadorias & Futuros-BM&F no responde por quaisquer erros ou omisses,
// dado que toda informao  provida "tal como est", sem nenhuma garantia de qualquer espcie. Nenhuma informao ou opinio
// aqui expressada constitui solicitao ou proposta de compra ou venda ou ainda oferta de compra ou de venda de qualquer dos
// contratos futuros e de opes negociados na Bolsa de Mercadorias & Futuros-BM&F, tampouco oferta de compra ou de venda de
// qualquer ttulo, valor mobilirio ou mercadoria aqui descrita como produto ou emisso. Como nenhuma informao disponvel
// neste cdigo de referncia deve servir de base para qualquer deciso de investimento, recomenda-se rigorosamente aos interessados que
// no confiem nem ajam fundamentados nas mesmas. Todavia, caso isso acontea, ser clara e inteiramente por sua conta e risco.
// Nem a Bolsa de Mercadorias & Futuros-BM&F nem seus executivos, diretores, associados, empregados, agentes, procuradores,
// consultores ou licenciados sero responsveis, perante qualquer pessoa (incluindo, mas no se limitando, um scio da Bolsa ou
// um cliente), por qualquer perda, dano, custo ou despesa (incluindo, mas no se limitando, lucros cessantes, impedimentos de uso
// ou danos diretos, indiretos, incidentais ou conseqentes) resultante de quaisquer erros, omisses ou alteraes nas informaes
// aqui fornecidas, tampouco por quaisquer atrasos, inexatides, erros, interrupes ou, ainda, quaisquer danos diretos ou
// conseqentes ocasionados ou mesmo ocorridos em funo do uso deste cdigo de referncia, nem, ainda, por qualquer prejuzo resultante de
// do seu mau uso, nem mesmo por qualquer descontinuidade do servio que venha a utiliz-lo.
// As disposies precedentes aplicam-se ainda que venha a surgir qualquer reivindicao ou pretenso de ordem contratual ou qualquer ao de
// reparao por ato ilcito extracontratual, negligncia, imprudncia, impercia, responsabilidade objetiva ou por qualquer outra maneira.
//
//
///////////////////////////////////////////////////////////
package br.com.bvmf.umdftcp.sample;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;
import java.util.logging.ConsoleHandler;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;


public class ProxyConfig {
	
	private static ProxyConfig instance = null;
	private Properties config = null;
	private FileOutputStream fixDump = null;
	private FileOutputStream zlibDump = null;
	
	protected ProxyConfig() {
		config = new Properties();
	}
	
	public int getLocalPort() {
		try {
			return Integer.parseInt(config.getProperty("localPort"));
		} catch (NumberFormatException e) {
			throw new RuntimeException("Missing localPort config.");
		}
	}
	
	public int getRemotePort() {
		try {
			return Integer.parseInt(config.getProperty("remotePort"));
		} catch (NumberFormatException e) {
			throw new RuntimeException("Missing remotePort config.");
		}
	}
	
	public int getTimeout() {
		try {
			return Integer.parseInt(config.getProperty("timeout"));
		} catch (NumberFormatException e) {
			throw new RuntimeException("Missing timeout config.");
		}
	}
	
	public String getRemoteHost() {
		String val = config.getProperty("remoteHost");
		if (val == null) throw new RuntimeException("Missing remoteHost config.");
		return val;
	}
	
	public FileOutputStream getFixDump() {
		return fixDump;
	}

	public FileOutputStream getZlibDump() {
		return zlibDump;
	}

	public static ProxyConfig getInstance() {
		if(instance == null) {
			instance = new ProxyConfig();
		}
		return instance;
	}

	static void logSetup() {
		instance = getInstance();
		Logger log = Logger.getLogger("InflatorProxy");
		log.addHandler(new ConsoleHandler());

		String logPath = instance.config.getProperty("logPath");
		if (logPath != null) {
			try {
				String logLevel = instance.config.getProperty("logLevel");
				if (logLevel == null) logLevel = "ALL";
				log.setLevel(Level.parse(logLevel)); 
				SimpleFormatter formatterTxt = new SimpleFormatter();
				FileHandler fileTxt = new FileHandler(logPath, 20000000, 10, true);
			    fileTxt.setFormatter(formatterTxt);
			    log.addHandler(fileTxt);
			} catch (IOException e) {
				System.err.println("Bad logPath:"+logPath);
				
			}
		}
	}
	
	static void loadConfig(String path) {
		instance = getInstance();
		try {
			instance.config.load(new FileInputStream(path));
			logSetup();
			String fixDumpPath = instance.config.getProperty("fixDumpPath");
			if (fixDumpPath != null) {
				instance.fixDump = new FileOutputStream(fixDumpPath, true);
			}
			
			String zlibDumpPath = instance.config.getProperty("zlibDumpPath");
			if (zlibDumpPath != null) {
				instance.zlibDump = new FileOutputStream(zlibDumpPath, true);
			}

		} catch (IOException e) {
			e.printStackTrace();
		}		
	}

}
